;******************************************************
;*                Musicians Toolbox                   *
;*                 By: Cullen Logan                   *
;*        Copyright 2000 All Rights Reserved          *
;*                                                    * 
;*Source Released as-is with no warranty of quality   *
;*or stability...I cannot be held responsile for any  *
;*damage done to your calculator by using this program*
;******************************************************
#define coordlength = 7

tempstore        = $CFAB   ; Temporary byte used in ASCR...Thanks Jimmy!
clipmask       = $C182   ; Temporary byte used in ASCR
rows2put       = $C183   ; Temporary byte used in ASCR
bitmask        = $C184   ; Temporary byte used in ASCR


#include "ti86asm.inc" 

.org _asm_exec_ram

    nop
    jp ProgStart
    .dw 0
    .dw ShellTitle

ShellTitle:
    .db "Musician's Toolbox",0

ProgStart:
    call _runindicoff ;turn that piece of shit off
    call _flushallmenus ;set the screen up for graphtext

mainloop:
    call _clrLCD ;clear the motha fuckin screen
    call _homeup ;cursor to top left
    call drawstaff ;draws the RLE staff
    call drawmenu ;call to function to make our side menu!
    call findkey ;see what key sig we should be outputting
    call makekeysig

changekeys:
    call _getkey
    cp kUp
    jp z,incindex
    cp kDown
    jp z,decindex
    cp kExit
    jp z,finish
    jr changekeys

incindex:
    ld a,(letterindex) ;get current index of array
    cp 29 ;if its 29 then there are no more key sigs
    jp z,changekeys ;so go back and wait for a keypress
    add a,2  ;only wastes 7 cycles as opposed to 8 with inc a inc a
    ld (letterindex),a ;load the keyindex variable with the new index number
    ld a,(keyindex)
    inc a
    ld (keyindex),a
    jp mainloop ;start over with new key sig!

decindex:
    ld a,(letterindex) ;get current index of array
    cp 1 ;if its 1 then there are no more key sigs
    jp z,changekeys ;so wait for another keypress
    sub 2 ;only wastes 7 cycles as opposed to 8 with dec a dec a
    ld (letterindex),a ;load the variable with the new index number
    ld a,(keyindex)
    dec a
    ld (keyindex),a
    jp mainloop ;start over with new index number

drawstaff:
    ld de,$fc00
    ld hl,Layer1 ;draws the pictures uses RLE compression!
    call DispRLE
    ld hl,256*58+25 ;location on screen to put string "key:"
    ld (_penCol),hl ;the rest of this Label just outputs text to the screen
    ld hl,key
    call _vputs
    ret

findkey:
    ld hl,256*58+40 ;coordinates to output text
    ld (_penCol),hl
    ld a,(letterindex);see how far we need to go into the keyarray
    ld b,a ;ld that into b to set up the loop
    ld hl,letternames ;laod hl with the address of the array
    call arraysearch ;dive into the array till we get where we need to be
    ld a,(hl) ;ld a with the character at that place
    call _vputmap ;output it to the screen
    inc hl ;this will advance our counter to the correct accidental following the key name
    ld a,(hl)   ;put it into A
    ld hl,256*58+45 ;output it
    ld (_penCol),hl
    call _vputmap
    ret

makekeysig: ;draw the key signature
    ld a,(keyindex)
    ld b,a
    ld hl,keys
    call arraysearch
    ld a,(hl) ;a holds the correct key signature
    cp 0 ;if it is zero then we are in the key of c return w/ out drawing anything
    ret z
    bit 7,a ;check for flat or sharp
    call z, usesharps
    call nz, useflats ;hl holds the Y coord array and the sprite is pushed to the stack
    ret

usesharps:
    call analyzekey    ;find out how many accidentals to draw
    call drawsharps    ;since we know it is a sharp key use sharps
    ret                 ;go back

useflats:
    call analyzekey     ;find out how many accidentals to draw
    call drawflats      ;since it is a flat key use flat sprite
    ret                 ;go back

drawsharps:
;b has number of accidentals
    ld hl,sharpcoords ;ld hl with the Y Coords of the sharps
    push bc           ;save # of accidentals or A.K.A the index
    call arraysearch  ;search the Y Coord array for the correct Y Coord
    ld a,(hl)         ;load the YCoord into A
    ld (ypos),a       ;save the YCoord into variable ypos
    pop bc            ;get the index back since it was dwindled to zero during our arraysearch's DJNZ
    push bc           ;save it again
    call getxpos      ;call Label to get the Coord.
    call drawsharpsprite ;call label to draw a sharp sprite
    pop bc              ;get our index back so that the djnz loop works correctly
    djnz drawsharps        ;repeat 0-6 times depending on value of B returned by analyzekey
    ret

drawflats:
    ld hl,flatcoords    ;does same as above but with flat sprites
    push bc
    call arraysearch
    ld a,(hl)
    ld (ypos),a
    pop bc
    push bc
    call getxpos
    call drawflatsprite
    pop bc
    djnz drawflats
    ret

getxpos:
    ld hl,XCoords
    call arraysearch
    ld a,(hl)
    ld (xpos),a
    ret

drawsharpsprite:
    ld hl,sharp
    ld a,(xpos)
    ld b,a
    ld a,(ypos)
    ld c,a
    ld de,tempstore
    call PutSprite_MSB
    ret

drawflatsprite:
    ld hl,flat
    ld a,(xpos)
    ld b,a
    ld a,(ypos)
    ld c,a
    ld de,tempstore
    call PutSprite_MSB
    ret


analyzekey:
    ld b,0  ;checking each bit and incrementing b everytime we encounter a 1!
    bit 6,a
    ret z 
    inc b
    bit 5,a
    ret z
    inc b
    bit 4,a
    ret z
    inc b
    bit 3,a
    ret z
    inc b
    bit 2,a
    ret z
    inc b
    bit 1,a
    ret z
    inc b
    bit 0,a
    ret z
    inc b
    ret

arraysearch:
    inc hl ; add one byte to hl untill we get to the correct location
    djnz arraysearch
    ret
dearraysearch:
    inc de
    djnz dearraysearch
    ret

drawmenu:
    ret





finish:
    call _clrLCD ;clear the screen
    ret ;exit the program

;**********
;* TABLES *
;********** 
ExpTable:
 .db $01,$80,$40,$20,$10,$08,$04,$02,$01

letternames:
    .db $01,$43,$20,$46,$20,$42,$62,$45,$62,$41,$62 ;table of key names with following accidental types
    .db $44,$62,$47,$62,$43,$62,$47,$20,$44,$20 ; 20 is natural 62 is flat and 23 is sharp
    .db $41,$20,$45,$20,$42,$20,$46,$23,$43,$23 ; dont forget it!!!
endofkeysigs:

keys:
    .db 1,0,192,224,240,248,252,254,255,64,96,112,120,124,126,127
endofkeys:


XCoords:
    .db 0,24,29,34,39,44,49,54
sharpcoords: ;used for the x and y coords of the accidental placements
    .db 0,17,29,13,25,37,21,33
flatcoords:
    .db 0,31,20,36,23,39,28,44


;
; FASTLINE 1.0
;
; BRESENHAM'S LINE ALGORITHM
; by Jimmy Mrdell <yarin@acc.umu.se>
;
; Parameters:  BC    = memory area to draw line (usually $FC00)
;              DE,HL = coordinates of line (D,E)-(H,L)
;                      0 < D,H < 128, 0 < E,L < 64
;
; Code size:   145 bytes (excluding FindPixel)
;             
; Registers:   AF destroyed.
;
; Performance: 4 times faster than Stephane Jantzens line routine
;
;              Delta_X > Delta_Y  =>  innerloop =  98.50 T states
;              Delta_Y > Delta_X  =>  innerloop = 106.75 T states
;

FLine:
 push bc
 push de
 push hl
 push bc
 ld a,h
 cp d
 jr nc,DXpos
 ex de,hl
DXpos:
 ld b,d
 ld c,e
 pop de
 push hl
 call FIND_PIXEL
 add hl,de
 ex (sp),hl
 ld e,c
 ld c,a
 ld a,h
 sub b
 ld b,a
 ld a,l
 sub e
 ld de,16
 jr nc,DYpos
 neg
 ld de,-16
DYpos:
 push af
 sub b
 jr nc,DY_Greater
 add a,a
 neg
 ld (x_ai+1),a
 pop af
 add a,a
 ld (XDNeg+1),a
 sub b
 pop hl
 push af
 ld a,c
 or (hl)
 ld (hl),a
 pop af
 bit 7,a
 jr nz,XDNeg
XNewRow:
 add hl,de
x_ai:
 sub 0
 push af
 rrc c
 jr nc,XNoWrap1
 inc hl
XNoWrap1:
 ld a,c
 or (hl)
 ld (hl),a
 pop af
 dec b
 jr z,LineDone
 jr nc,XNewRow
XDNeg:
 add a,0
 push af
 rrc c
 jr nc,XNoWrap2
 inc hl
XNoWrap2:
 ld a,c
 or (hl)
 ld (hl),a
 pop af
 dec b
 jr z,LineDone
 jr c,XNewRow
 jr XDNeg
DY_Greater:
 neg
 add a,a
 ld (YNoWrap+1),a
 ld a,b
 add a,a
 ld (YDNeg+1),a
 pop hl
 sub h
 ld b,h
 pop hl
 push af
 ld a,c
 or (hl)
 ld (hl),a
 pop af
YRepeat:
 bit 7,a
 jr nz,YDNeg
 rrc c
 jr nc,YNoWrap
 inc hl
YNoWrap:
 add a,0
 jr YPlot
YDNeg:
 add a,0
YPlot:
 add hl,de
 push af
 ld a,c
 or (hl)
 ld (hl),a
 pop af
 djnz YRepeat
LineDone:
 pop hl
 pop de
 pop bc
 ret


; ASCR  - Advanced Sprite Clipping Routines
;
;   by Jimmy Mrdell    970304   Last update 970803
;
; Temporary variables needed:
;  clipmask  : Byte
;  rows2put  : Byte
;  bitmask   : Byte
;
;
; PutSprite_MSB:
;  Puts an 8x8 sprite at coordinates B,C. HL should point to a bitmapped
;  sprite followed by a bitmapped mask, total 16 bytes. DE should point
;  to an a memory location where the background will be stored as a
;  bitmap (8 bytes). The sprite will be clipped.
;
; PutSprite:
;  Puts an 8x8 sprite at B,C. HL = pointer to sprite. No mask and no
;  background storage, just clipping.


PutSprite_MSB:      ; BC = x,y  DE = background storage  HL = sprite + mask
 ld a,c
 cp 150
 jr nc,PMSB_NoBotClip
 cp 64
 ret nc
PMSB_NoBotClip:
 push bc
 push de
 push hl
 push ix
 ld a,$FF
 ld (clipmask),a
 bit 7,b
 jr z,PMSB_CheckRightClip
 ld a,b
 cp 249
 jr c,EndPMSB
 neg
 push bc
 ld b,a
 ld a,$FF
PMSB_LeftClip:
 srl a
 djnz PMSB_LeftClip
 pop bc
 res 7,b
 dec c
 ld (clipmask),a
 jr PMSB_CheckBotClip
PMSB_CheckRightClip
 ld a,b
 sub 113
 jr c,PMSB_CheckBotClip
 push bc
 ld b,a
 inc b
 ld a,$FF
PMSB_RightClip:
 add a,a
 djnz PMSB_RightClip
 ld (clipmask),a
 pop bc
PMSB_CheckBotClip:
 ld a,8
 ld (rows2put),a
 bit 7,c
 jr nz,PMSB_CheckTopClip
 bit 6,c
 jp nz,EndMSB
 ld a,64
 sub c
 cp 8
 jr nc,PMSB_ClippingDone
 ld (rows2put),a
 jr PMSB_ClippingDone
PMSB_CheckTopClip:
 ld a,c
 cp 249
EndPMSB:
 jr c,EndMSB
 ret c
 push bc
 neg
 ld b,a
 sub 8
 neg
 ld (rows2put),a
PMSB_TopClip:
 inc hl
 inc de
 djnz PMSB_TopClip
 pop bc
 ld c,0
PMSB_ClippingDone:
 di
 push iy
 push hl
 pop iy
 push de
 pop ix
 ld a,(rows2put)
 push af
 call FIND_PIXEL
Modify_5:
 ld de,$FC00
 add hl,de
 ld (bitmask),a
 pop bc
PMSB_PutRow:
 push bc
 push hl
 ld a,(clipmask)
 ld e,a
 ld a,(iy+8)
 and e
 ld e,a      ; e = mask for this row
 ld d,0      ; d = background for this row
 ld b,8      ; b = pixels left to put
 ld c,(iy) ; c = sprite row
 inc iy
PMSB_PutCol:
 push bc
 sla d
 ld a,(bitmask)
 and (hl)
 jr z,PMSB_NPH
 inc d
PMSB_NPH:
 rlc e
 jr nc,PMSB_NextBit
 ld a,(bitmask)
 rlc c
 jr c,PMSB_BitOn
 cpl
 and (hl)
 ld (hl),a
 jr PMSB_NextBit
PMSB_BitOn:
 or (hl)
 ld (hl),a
PMSB_NextBit:
 ld a,(bitmask)
 rrca
 ld (bitmask),a
 jr nc,PMSB_SSB
 inc hl
PMSB_SSB:
 pop bc
 rlc c
 djnz PMSB_PutCol
 ld (ix),d
 inc ix
 pop hl
 ld de,16
 add hl,de
 pop bc
 djnz PMSB_PutRow
 pop iy
 ei
EndMSB:
 pop ix
 pop hl
 pop de
 pop bc
 ret

PutSprite:       ; BC = x,y  HL = sprite
 push bc
 push de
 push hl
 push ix
 ld a,$FF
 ld (clipmask),a
 bit 7,b
 jr z,PSC_CheckRightClip
 ld a,b
 cp 249
 jr c,EndPPS
 neg
 push bc
 ld b,a
 ld a,$FF
PSC_LeftClip:
 srl a
 djnz PSC_LeftClip
 pop bc
 res 7,b
 dec c
 ld (clipmask),a
 jr PSC_CheckBotClip
PSC_CheckRightClip
 ld a,b
 sub 113
 jr c,PSC_CheckBotClip
 push bc
 ld b,a
 inc b
 ld a,$FF
PSC_RightClip:
 add a,a
 djnz PSC_RightClip
 ld (clipmask),a
 pop bc
PSC_CheckBotClip:
 ld a,8
 ld (rows2put),a
 bit 7,c
 jr nz,PSC_CheckTopClip
 bit 6,c
 jr nz,EndPS
 ld a,64
 sub c
 cp 8
 jr nc,PSC_ClippingDone
 ld (rows2put),a
 jr PSC_ClippingDone
PSC_CheckTopClip:
 ld a,c
 cp 249
EndPPS:
 jr c,EndPS
 push bc
 neg
 ld b,a
 sub 8
 neg
 ld (rows2put),a
PSC_TopClip:
 inc hl
 inc de
 djnz PSC_TopClip
 pop bc
 ld c,0
PSC_ClippingDone:
 push hl
 pop ix
 ld a,(rows2put)
 push af
 call FIND_PIXEL
Modify_6:
 ld de,$FC00
 add hl,de
 ld d,a
 pop bc
PSC_PutRow:
 push bc
 push hl
 ld a,(clipmask)
 ld e,a
 ld b,8
 ld c,(ix)
 inc ix
PSC_PutCol:
 push bc
 rlc e
 jr nc,PSC_NextBit
 ld a,d
 rlc c
 jr c,PSC_BitOn
 cpl
 and (hl)
 ld (hl),a
 jr PSC_NextBit
PSC_BitOn:
 or (hl)
 ld (hl),a
PSC_NextBit:
 rrc d
 jr nc,PSC_SSB
 inc hl
PSC_SSB:
 pop bc
 rlc c
 djnz PSC_PutCol
 pop hl
 ld bc,16
 add hl,bc
 pop bc
 djnz PSC_PutRow
EndPS:
 pop ix
 pop hl
 pop de
 pop bc
 ret

FIND_PIXEL:
 push bc
 push de
 ld hl,ExpTable+1
 ld d,0
 ld a,b
 and $07
 ld e,a
 add hl,de
 ld e,(hl)
 ld h,d
 srl b
 srl b
 srl b
 ld a,c
 add a,a
 add a,a
 ld l,a
 add hl,hl
 add hl,hl
 ld a,e
 ld e,b
 add hl,de
 pop de
 pop bc
 ret


;===========================================================
; RLE picture displayer v1.1
; Decodes a RLE picture made by RLE2PIC
;
; written by David Phillips <electrum@tfs.net>
; started: 8/19/98
; last update: 11/5/98
;
; input: HL = RLE encoded picture, DE = where to display
; output: 1024 byte decoded picture
; destroys: AF, BC, DE, HL
; current size: 32 bytes
;===========================================================
DispRLE:
 ld bc,1024         ; we need to copy 
DispRLEL:
 ld a,(hl)          ; get the next byte
 cp $91             ; is it a run?
 jr z,DispRLERun    ; then we need to decode the run
 ldi                ; copy the byte, and update counters
DispRLEC:
 ld a,b             ; check the low byte and
 or c               ; the high byte for 0
 jr nz,DispRLEL     ; if not, then we're not done either
 ret                ; if it's zero, we're done
DispRLERun:
 inc hl             ; move to the run value
 ld a,(hl)          ; get the run value
 inc hl             ; move to the run count
 push hl            ; save source pointer
 ld h,(hl)          ; get the run count
 ex de,hl           ; swap source and destination pointers
DispRLERunL:
 ld (hl),a          ; copy the byte
 inc hl             ; increase destination pointer
 dec bc             ; decrease byte count
 dec d              ; decrease run count
 jr nz,DispRLERunL  ; if we're not done, then loop
 ex de,hl           ; swap pointers back
 pop hl             ; recover source pointer
 inc hl             ; advance the source pointer
 jr DispRLEC        ; check to see if we should loop

;***********************End of RLE OUTPUT*******************************





;***************
;*   Sprites   *
;***************
sprites:

sharp:  ;sharp sign raises one half step
.db %01000100
.db %11111110
.db %01000100
.db %01000100
.db %01000100
.db %11111110
.db %01000100
.db %00000000
.db %01000100
.db %11111110
.db %01000100
.db %01000100
.db %01000100
.db %11111110
.db %01000100
.db %00000000

flat:   ;flat sign lowers one half step
.db %10000000
.db %10000000
.db %10000000
.db %10110000
.db %11001000
.db %10001000
.db %10010000
.db %11100000
.db %10000000
.db %10000000
.db %10000000
.db %10110000
.db %11001000
.db %10001000
.db %10010000
.db %11100000

   
note:   ;whole note for writing chords
.db %00000000
.db %00111100
.db %01000010
.db %10000001
.db %10000001
.db %10000001
.db %01000010
.db %00111100

quarter:
.db %11111111
.db %00100010
.db %11111111
.db %00100010
.db %00100010
.db %00100010
.db %11101110
.db %11101110
.db %11111111
.db %00100010
.db %11111111
.db %00100010
.db %00100010
.db %00100010
.db %11101110
.db %11101110


;******************************************************************
;*                      Treble Clef and Staff                     *
;******************************************************************
Layer1:
 .db $91,$00,$09,$08,$91,$00,$0f,$08,$91,$00,$0f,$08,$91,$00,$0f,$08
 .db $91,$00,$0f,$08,$91,$00,$0f,$08,$91,$00,$0f,$08,$91,$00,$0f,$08
 .db $91,$00,$0f,$08,$91,$00,$0f,$08,$91,$00,$0f,$08,$91,$00,$0f,$08
 .db $91,$00,$0f,$08,$91,$00,$0f,$08,$91,$00,$07,$1c,$91,$00,$07,$08
 .db $91,$00,$07,$3e,$91,$00,$07,$08,$91,$00,$07,$7e,$91,$00,$07,$08
 .db $91,$00,$07,$7e,$91,$00,$07,$08,$91,$00,$07,$f9,$91,$00,$06,$3c
 .db $08,$91,$00,$07,$f1,$91,$00,$06,$20,$08,$91,$00,$06,$91,$ff,$08
 .db $b8,$08,$91,$00,$06,$01,$e1,$91,$00,$06,$20,$08,$91,$00,$06,$01
 .db $c1,$91,$00,$06,$21,$e8,$91,$00,$06,$01,$c1,$91,$00,$06,$01,$08
 .db $91,$00,$07,$83,$91,$00,$06,$01,$c8,$91,$00,$07,$83,$91,$00,$06
 .db $01,$08,$91,$00,$07,$8f,$91,$00,$06,$39,$e8,$91,$00,$07,$9e,$91
 .db $00,$06,$24,$08,$91,$00,$06,$91,$ff,$08,$a4,$08,$91,$00,$06,$01
 .db $fc,$91,$00,$06,$24,$08,$91,$00,$06,$01,$f8,$91,$00,$06,$39,$e8
 .db $91,$00,$06,$03,$f0,$91,$00,$06,$01,$08,$91,$00,$06,$07,$e0,$91
 .db $00,$06,$01,$08,$91,$00,$06,$07,$e0,$91,$00,$06,$01,$08,$91,$00
 .db $06,$1f,$30,$91,$00,$06,$39,$e8,$91,$00,$06,$3e,$30,$91,$00,$06
 .db $24,$08,$91,$00,$06,$91,$ff,$08,$b8,$08,$91,$00,$06,$7c,$f0,$91
 .db $00,$06,$24,$08,$91,$00,$06,$78,$ff,$80,$91,$00,$05,$38,$c8,$91
 .db $00,$06,$f1,$ff,$c0,$91,$00,$05,$01,$28,$91,$00,$06,$f3,$d9,$e0
 .db $91,$00,$05,$01,$e8,$91,$00,$06,$e3,$18,$60,$91,$00,$05,$01,$28
 .db $91,$00,$06,$e3,$18,$60,$91,$00,$05,$3d,$28,$91,$00,$06,$e3,$18
 .db $20,$91,$00,$05,$20,$08,$91,$00,$06,$91,$ff,$08,$ac,$08,$91,$00
 .db $06,$73,$0c,$20,$91,$00,$05,$24,$08,$91,$00,$06,$71,$8c,$20,$91
 .db $00,$05,$3d,$e8,$91,$00,$06,$38,$7c,$60,$91,$00,$05,$01,$08,$91
 .db $00,$06,$1c,$0c,$40,$91,$00,$05,$01,$c8,$91,$00,$06,$07,$03,$80
 .db $91,$00,$05,$01,$08,$91,$00,$07,$fe,$91,$00,$06,$3d,$08,$91,$00
 .db $07,$fe,$91,$00,$06,$20,$08,$91,$00,$06,$91,$ff,$08,$b8,$08,$91
 .db $00,$07,$02,$91,$00,$06,$20,$08,$91,$00,$06,$03,$f2,$91,$00,$06
 .db $3c,$08,$91,$00,$06,$03,$f2,$91,$00,$07,$08,$91,$00,$06,$03,$f2
 .db $91,$00,$07,$08,$91,$00,$06,$03,$f2,$91,$00,$07,$08,$91,$00,$06
 .db $02,$c2,$91,$00,$07,$08,$91,$00,$06,$01,$02,$91,$00,$07,$08,$91
 .db $00,$07,$fc,$91,$00,$07,$08,$91,$00,$0f,$08,$91,$00,$0f,$08,$91
 .db $00,$0f,$08,$91,$00,$06

Layer2:
 .db $91,$00,$09,$08,$91,$00,$0f,$08,$91,$00,$0f,$08,$91,$00,$0f,$08
 .db $91,$00,$0f,$08,$91,$00,$0f,$08,$91,$00,$0f,$08,$91,$00,$0f,$08
 .db $91,$00,$0f,$08,$91,$00,$0f,$08,$91,$00,$0f,$08,$91,$00,$0f,$08
 .db $91,$00,$0f,$08,$91,$00,$0f,$08,$91,$00,$07,$1c,$91,$00,$07,$08
 .db $91,$00,$07,$3e,$91,$00,$07,$08,$91,$00,$07,$7e,$91,$00,$07,$08
 .db $91,$00,$07,$7e,$91,$00,$07,$08,$91,$00,$07,$f9,$91,$00,$06,$3c
 .db $08,$91,$00,$07,$f1,$91,$00,$06,$20,$08,$91,$00,$06,$91,$ff,$08
 .db $b8,$08,$91,$00,$06,$01,$e1,$91,$00,$06,$20,$08,$91,$00,$06,$01
 .db $c1,$91,$00,$06,$21,$e8,$91,$00,$06,$01,$c1,$91,$00,$06,$01,$08
 .db $91,$00,$07,$83,$91,$00,$06,$01,$c8,$91,$00,$07,$83,$91,$00,$06
 .db $01,$08,$91,$00,$07,$8f,$91,$00,$06,$39,$e8,$91,$00,$07,$9e,$91
 .db $00,$06,$24,$08,$91,$00,$06,$91,$ff,$08,$a4,$08,$91,$00,$06,$01
 .db $fc,$91,$00,$06,$24,$08,$91,$00,$06,$01,$f8,$91,$00,$06,$39,$e8
 .db $91,$00,$06,$03,$f0,$91,$00,$06,$01,$08,$91,$00,$06,$07,$e0,$91
 .db $00,$06,$01,$08,$91,$00,$06,$07,$e0,$91,$00,$06,$01,$08,$91,$00
 .db $06,$1f,$30,$91,$00,$06,$39,$e8,$91,$00,$06,$3e,$30,$91,$00,$06
 .db $24,$08,$91,$00,$06,$91,$ff,$08,$b8,$08,$91,$00,$06,$7c,$f0,$91
 .db $00,$06,$24,$08,$91,$00,$06,$78,$ff,$80,$91,$00,$05,$38,$c8,$91
 .db $00,$06,$f1,$ff,$c0,$91,$00,$05,$01,$28,$91,$00,$06,$f3,$d9,$e0
 .db $91,$00,$05,$01,$e8,$91,$00,$06,$e3,$18,$60,$91,$00,$05,$01,$28
 .db $91,$00,$06,$e3,$18,$60,$91,$00,$05,$3d,$28,$91,$00,$06,$e3,$18
 .db $20,$91,$00,$05,$20,$08,$91,$00,$06,$91,$ff,$08,$ac,$08,$91,$00
 .db $06,$73,$0c,$20,$91,$00,$05,$24,$08,$91,$00,$06,$71,$8c,$20,$91
 .db $00,$05,$3d,$e8,$91,$00,$06,$38,$7c,$60,$91,$00,$05,$01,$08,$91
 .db $00,$06,$1c,$0c,$40,$91,$00,$05,$01,$c8,$91,$00,$06,$07,$03,$80
 .db $91,$00,$05,$01,$08,$91,$00,$07,$fe,$91,$00,$06,$3d,$08,$91,$00
 .db $07,$fe,$91,$00,$06,$20,$08,$91,$00,$06,$91,$ff,$08,$b8,$08,$91
 .db $00,$07,$02,$91,$00,$06,$20,$08,$91,$00,$06,$03,$f2,$91,$00,$06
 .db $3c,$08,$91,$00,$06,$03,$f2,$91,$00,$07,$08,$91,$00,$06,$03,$f2
 .db $91,$00,$07,$08,$91,$00,$06,$03,$f2,$91,$00,$07,$08,$91,$00,$06
 .db $02,$c2,$91,$00,$07,$08,$91,$00,$06,$01,$02,$91,$00,$07,$08,$91
 .db $00,$07,$fc,$91,$00,$07,$08,$91,$00,$0f,$08,$91,$00,$0f,$08,$91
 .db $00,$0f,$08,$91,$00,$06

; Total compression: 2048 bytes compressed to 1036 (49% smaller)
    
;*************
;*  STRINGS  *    
;*************    
z80ac:
    .db " z80 AC ",0
key:
    .db "Key:",0    
author:
    .db "By: Cullen Logan",0
tips:
    .text "F1: Tips"

orderofsharps:
    .text "Funcky Chickens Get Down At Ed's Bar"

menu:
    .text "F1: Tips" ;could have used .db then a 0 terminator but assembler directives are cool!
    
;*************
;* VARIABLES *    
;*************

letterindex:
    .db 1
keyindex:
    .db 1
currentsig
.db 0
xpos:
    .db 0
ypos:
    .db 0


.end